commit d8426ffb6e7d080257461963a7fef18d48203e9c
Author: Miltiadis Vasilakis <mvasilak@gmail.com>
Date:   Wed Feb 29 21:51:58 2012 +0200

    Support multiple accounts. Bug fixes. Improve concurrency.

diff --git a/pithos-apple-common b/pithos-apple-common
index 308855b..097cb83 160000
--- a/pithos-apple-common
+++ b/pithos-apple-common
@@ -1 +1 @@
-Subproject commit 308855b44f430202033eda90f597f6abdae5ea80
+Subproject commit 097cb8319ef7a831c06f6154df3c63b043382ff2
diff --git a/pithos-macos/LastCompletedSyncTransformer.m b/pithos-macos/LastCompletedSyncTransformer.m
index ecdaf44..8f6b471 100644
--- a/pithos-macos/LastCompletedSyncTransformer.m
+++ b/pithos-macos/LastCompletedSyncTransformer.m
@@ -2,7 +2,7 @@
 //  LastCompletedSyncTransformer.m
 //  pithos-macos
 //
-// Copyright 2011 GRNET S.A. All rights reserved.
+// Copyright 2011-2012 GRNET S.A. All rights reserved.
 //
 // Redistribution and use in source and binary forms, with or
 // without modification, are permitted provided that the following
@@ -49,7 +49,7 @@
 
 - (id)transformedValue:(id)value {
     if (value == nil)
-		return @"Last Sync: -";
+		return @"-";
     
     NSCalendar *calendar = [NSCalendar currentCalendar];
     NSDateComponents *comps = [calendar components:(NSYearCalendarUnit | NSMonthCalendarUnit | NSDayCalendarUnit) fromDate:[NSDate date]];
@@ -59,16 +59,16 @@
     NSTimeInterval timeInterval = [[calendar dateFromComponents:comps] timeIntervalSinceDate:(NSDate *)value];
     if (timeInterval < 86400) {
         // Today
-        return [NSString stringWithFormat:@"Last Sync: Today %@", [NSDateFormatter localizedStringFromDate:(NSDate *)value 
+        return [NSString stringWithFormat:@"Today %@", [NSDateFormatter localizedStringFromDate:(NSDate *)value 
                                                                                                      dateStyle:NSDateFormatterNoStyle 
                                                                                                      timeStyle:NSDateFormatterShortStyle]];
     } else if (timeInterval < 172800) {
         // Yesterday
-        return [NSString stringWithFormat:@"Last Sync: Yesterday %@", [NSDateFormatter localizedStringFromDate:(NSDate *)value 
+        return [NSString stringWithFormat:@"Yesterday %@", [NSDateFormatter localizedStringFromDate:(NSDate *)value 
                                                                                            dateStyle:NSDateFormatterNoStyle 
                                                                                            timeStyle:NSDateFormatterShortStyle]];
     } else {
-        return [NSString stringWithFormat:@"Last Sync: %@", [NSDateFormatter localizedStringFromDate:(NSDate *)value 
+        return [NSString stringWithFormat:@"%@", [NSDateFormatter localizedStringFromDate:(NSDate *)value 
                                                                                            dateStyle:NSDateFormatterShortStyle 
                                                                                            timeStyle:NSDateFormatterShortStyle]];
     }
diff --git a/pithos-macos/PithosAccount.h b/pithos-macos/PithosAccount.h
new file mode 100644
index 0000000..9aae18e
--- /dev/null
+++ b/pithos-macos/PithosAccount.h
@@ -0,0 +1,112 @@
+//
+//  PithosAccount.h
+//  pithos-macos
+//
+// Copyright 2012 GRNET S.A. All rights reserved.
+//
+// Redistribution and use in source and binary forms, with or
+// without modification, are permitted provided that the following
+// conditions are met:
+// 
+//   1. Redistributions of source code must retain the above
+//      copyright notice, this list of conditions and the following
+//      disclaimer.
+// 
+//   2. Redistributions in binary form must reproduce the above
+//      copyright notice, this list of conditions and the following
+//      disclaimer in the documentation and/or other materials
+//      provided with the distribution.
+// 
+// THIS SOFTWARE IS PROVIDED BY GRNET S.A. ``AS IS'' AND ANY EXPRESS
+// OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL GRNET S.A OR
+// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+// USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
+// AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
+// ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+// POSSIBILITY OF SUCH DAMAGE.
+// 
+// The views and conclusions contained in the software and
+// documentation are those of the authors and should not be
+// interpreted as representing official policies, either expressed
+// or implied, of GRNET S.A.
+
+#import <Foundation/Foundation.h>
+@class PithosSyncDaemon;
+@class ASIPithos;
+@class PithosAccountNode;
+
+@interface PithosAccount : NSObject <NSCoding> {
+    NSString *uniqueName;
+    BOOL active;
+    NSString *name;
+    
+    BOOL syncActive;
+    NSString *syncDirectoryPath;
+    NSString *syncContainerName;
+    NSDate *syncLastCompleted;
+    PithosSyncDaemon *syncDaemon;
+        
+    // Base for all necessary URLs, default "https://plus.pithos.grnet.gr"
+    NSString *serverURL;
+    // Appended to serverURL to get storageURLPrefix and authURL, default "v1"
+    // Can be overriden by setting directly storageURLPrefix and authURL
+    NSString *versionResource;
+    // Appended to serverURL to get loginURLPrefix, default "login"
+    // Can be overriden by setting directly loginURLPrefix
+    NSString *loginResource;
+    // Appended to serverURL to get publicURLPrefix, default nil
+    // Can be overriden by setting directly publicURLPrefix
+    NSString *publicResource;
+
+    NSString *authUser;
+    NSString *authToken;
+    NSString *storageURLPrefix;
+    NSString *authURL;
+    NSString *publicURLPrefix;
+    NSString *loginURLPrefix;
+    
+    ASIPithos *pithos;
+    PithosAccountNode *accountNode;
+    
+    BOOL updatePithos;
+    BOOL resetSyncDaemonLocalState;
+}
+
+@property (nonatomic, retain) NSString *uniqueName;
+@property (assign) BOOL active;
+@property (nonatomic, retain) NSString *name;
+
+@property (nonatomic, assign) BOOL syncActive;
+@property (nonatomic, retain) NSString *syncDirectoryPath;
+@property (nonatomic, retain) NSString *syncContainerName;
+@property (nonatomic, retain) NSDate *syncLastCompleted;
+@property (nonatomic, retain) PithosSyncDaemon *syncDaemon;
+
+@property (nonatomic, retain) NSString *serverURL;
+@property (retain) NSString *versionResource;
+@property (retain) NSString *loginResource;
+@property (retain) NSString *publicResource;
+
+@property (nonatomic, retain) NSString *authUser;
+@property (nonatomic, retain) NSString *authToken;
+@property (nonatomic, retain) NSString *storageURLPrefix;
+@property (nonatomic, retain) NSString *authURL;
+@property (nonatomic, retain) NSString *publicURLPrefix;
+@property (nonatomic, retain) NSString *loginURLPrefix;
+
+@property (readonly) ASIPithos *pithos;
+@property (readonly) PithosAccountNode *accountNode;
+
++ (id)pithosAccount;
+
+- (BOOL)urlIsValid:(NSString *)urlString;
+- (void)authenticateWithServerURL:(NSString *)aServerURL authUser:(NSString *)anAuthUser authToken:(NSString *)anAuthToken;
+- (void)loginWithServerURL:(NSString *)aServerURL;
+- (void)updateSyncWithSyncActive:(BOOL)aSyncActive syncDirectoryPath:(NSString *)aSyncDirectoryPath;
+
+@end
diff --git a/pithos-macos/PithosAccount.m b/pithos-macos/PithosAccount.m
new file mode 100644
index 0000000..f97b23f
--- /dev/null
+++ b/pithos-macos/PithosAccount.m
@@ -0,0 +1,473 @@
+//
+//  PithosAccount.m
+//  pithos-macos
+//
+// Copyright 2012 GRNET S.A. All rights reserved.
+//
+// Redistribution and use in source and binary forms, with or
+// without modification, are permitted provided that the following
+// conditions are met:
+// 
+//   1. Redistributions of source code must retain the above
+//      copyright notice, this list of conditions and the following
+//      disclaimer.
+// 
+//   2. Redistributions in binary form must reproduce the above
+//      copyright notice, this list of conditions and the following
+//      disclaimer in the documentation and/or other materials
+//      provided with the distribution.
+// 
+// THIS SOFTWARE IS PROVIDED BY GRNET S.A. ``AS IS'' AND ANY EXPRESS
+// OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL GRNET S.A OR
+// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+// USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
+// AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
+// ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+// POSSIBILITY OF SUCH DAMAGE.
+// 
+// The views and conclusions contained in the software and
+// documentation are those of the authors and should not be
+// interpreted as representing official policies, either expressed
+// or implied, of GRNET S.A.
+
+#import "PithosAccount.h"
+#import "PithosSyncDaemon.h"
+#import "ASIPithos.h"
+#import "PithosAccountNode.h"
+#import "pithos_macosAppDelegate.h"
+
+@interface PithosAccount (Internal)
+- (BOOL)urlIsValid:(NSString *)urlString;
+@end
+
+@implementation PithosAccount
+@synthesize uniqueName, active, name;
+@synthesize syncActive, syncDirectoryPath, syncContainerName, syncLastCompleted, syncDaemon;
+@synthesize serverURL, versionResource, loginResource, publicResource;
+@synthesize authUser, authToken, storageURLPrefix, authURL, loginURLPrefix, publicURLPrefix;
+@synthesize pithos, accountNode;
+
+#pragma mark -
+#pragma mark Object Lifecycle
+
++ (id)pithosAccount {
+    PithosAccount *pithosAccount = [[[self alloc] init] autorelease];
+    pithosAccount.uniqueName = [NSString stringWithFormat:@"pithosAccount-%f", [NSDate timeIntervalSinceReferenceDate]];
+    pithosAccount.versionResource = [NSString stringWithString:@"v1"];
+    pithosAccount.loginResource = [NSString stringWithString:@"login"];
+    return pithosAccount;
+}
+
+- (void)dealloc {
+    [accountNode release];
+    [pithos release];
+    [publicURLPrefix release];
+    [loginURLPrefix release];
+    [authURL release];
+    [storageURLPrefix release];
+    [authToken release];
+    [authUser release];
+    [publicResource release];
+    [loginResource release];
+    [versionResource release];
+    [serverURL release];
+    [syncDaemon release];
+    [syncLastCompleted release];
+    [syncContainerName release];
+    [syncDirectoryPath release];
+    [name release];
+    [uniqueName release];
+    [super dealloc];
+}
+
+- (NSString *)description {
+    return [NSString stringWithFormat:@"uniqueName: %@, active: %d, name: %@, syncActive: %d, syncDirectoryPath: %@, syncContainerName: %@, syncLastCompleted: %@, serverURL: %@, versionResource: %@, loginResource: %@, publicResource: %@, authUser: %@, authToken: %@, storageURLPrefix: %@, authURL: %@, loginURLPrefix: %@, publicURLPrefix: %@", 
+            uniqueName, active, name, syncActive, syncDirectoryPath, syncContainerName, syncLastCompleted, serverURL, versionResource, loginResource, publicResource, authUser, authToken, storageURLPrefix, authURL, loginURLPrefix, publicURLPrefix];
+}
+
+#pragma mark -
+#pragma mark Internal
+
+- (BOOL)urlIsValid:(NSString *)urlString {
+    if (urlString) {
+        NSURL *url = [NSURL URLWithString:urlString];
+        if (url && url.scheme && url.host)
+            return YES;
+    }
+    return NO;
+}
+
+#pragma mark -
+#pragma mark Properties
+
+- (NSString *)name {
+    if (![name length]) {
+        [name release];
+        NSDictionary *pithosAccountsDictionary = [(pithos_macosAppDelegate *)[[NSApplication sharedApplication] delegate] pithosAccountsDictionary];
+        NSString *namePrefix = [NSString stringWithString:@"okeanos"];
+        NSUInteger nameSuffix = 1;
+        name = [NSString stringWithString:@"okeanos"];
+        NSString *documentsDirectoryPath = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
+        NSFileManager *fileManager = [NSFileManager defaultManager];
+        while ([pithosAccountsDictionary objectForKey:name] || 
+               [fileManager fileExistsAtPath:[documentsDirectoryPath stringByAppendingPathComponent:name]]) {
+            name = [NSString stringWithFormat:@"%@%d", namePrefix, ++nameSuffix];
+        }
+        [name retain];
+    }
+    return name;
+}
+
+- (void)setName:(NSString *)aName {
+    NSMutableDictionary *pithosAccountsDictionary = [(pithos_macosAppDelegate *)[[NSApplication sharedApplication] delegate] pithosAccountsDictionary];
+    if (![self.name isEqualToString:aName] && [aName length] && ![pithosAccountsDictionary objectForKey:aName]) {
+        [pithosAccountsDictionary setObject:self forKey:aName];
+        [pithosAccountsDictionary removeObjectForKey:name];
+        [name release];
+        name = [aName retain];
+    }
+}
+
+- (BOOL)syncActive {
+    if (active)
+        return syncActive;
+    else
+        return NO;
+}
+
+- (void)setSyncActive:(BOOL)aSyncActive {
+    syncActive = aSyncActive;
+    if (syncDaemon && !self.syncActive)
+        [syncDaemon resetDaemon];
+}
+
+- (NSString *)syncDirectoryPath {
+    if (![syncDirectoryPath length]) {
+        [syncDirectoryPath release];
+        syncDirectoryPath = [[[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0] 
+                              stringByAppendingPathComponent:self.name] retain];
+    }
+    return syncDirectoryPath;
+}
+
+- (void)setSyncDirectoryPath:(NSString *)aSyncDirectoryPath {
+    if (![self.syncDirectoryPath isEqualToString:aSyncDirectoryPath] && [aSyncDirectoryPath length]) {
+        BOOL isDirectory;
+        if (![[NSFileManager defaultManager] fileExistsAtPath:aSyncDirectoryPath isDirectory:&isDirectory] || isDirectory) {
+            [syncDirectoryPath release];
+            syncDirectoryPath = [aSyncDirectoryPath retain];
+        } else {
+            return;
+        }
+
+        @synchronized(self) {
+            resetSyncDaemonLocalState = YES;
+            [syncLastCompleted release];
+            syncLastCompleted = nil;
+        }
+    }
+}
+
+- (NSString *)syncContainerName {
+    if (![syncContainerName length]) {
+        [syncContainerName release];
+        syncContainerName = [[NSString stringWithString:@"pithos"] retain];
+    }        
+    return syncContainerName;
+}
+
+- (void)setSyncContainerName:(NSString *)aSyncContainerName {
+    if (![self.syncContainerName isEqualToString:aSyncContainerName] && [aSyncContainerName length]) {
+        [syncContainerName release];
+        syncContainerName = [aSyncContainerName retain];
+        
+        @synchronized(self) {
+            resetSyncDaemonLocalState = YES;
+            [syncLastCompleted release];
+            syncLastCompleted = nil;
+        }
+    }
+}
+
+- (NSDate *)syncLastCompleted {
+    if (self.syncDaemon.lastCompletedSync && ![self.syncDaemon.lastCompletedSync isEqualToDate:syncLastCompleted]) {
+        [syncLastCompleted release];
+        syncLastCompleted = [self.syncDaemon.lastCompletedSync copy];
+    }
+    return syncLastCompleted;
+}
+
+- (PithosSyncDaemon *)syncDaemon {
+    @synchronized(self) {
+        if (self.syncActive && !syncDaemon)
+            syncDaemon = [[PithosSyncDaemon alloc] initWithDirectoryPath:self.syncDirectoryPath 
+                                                           pithosAccount:self 
+                                                           containerName:self.syncContainerName 
+                                                         resetLocalState:resetSyncDaemonLocalState];
+        resetSyncDaemonLocalState = NO;
+    }
+    return syncDaemon;
+}
+
+- (NSString *)serverURL {
+    if (![self urlIsValid:serverURL]) {
+        [serverURL release];
+        serverURL = [[NSString stringWithString:@"https://plus.pithos.grnet.gr"] retain];
+    }
+    return serverURL;
+}
+
+- (void)setServerURL:(NSString *)aServerURL {
+    if (![self.serverURL isEqualToString:aServerURL] && [self urlIsValid:aServerURL]) {
+        [serverURL release];
+        serverURL = [aServerURL retain];
+        [storageURLPrefix release];
+        storageURLPrefix = nil;
+        [authURL release];
+        authURL = nil;
+        [publicURLPrefix release];
+        publicURLPrefix = nil;
+        [loginURLPrefix release];
+        loginURLPrefix = nil;
+
+        @synchronized(self) {
+            updatePithos = YES;
+            resetSyncDaemonLocalState = YES;
+            [syncLastCompleted release];
+            syncLastCompleted = nil;
+        }
+    }
+}
+
+- (void)setAuthUser:(NSString *)anAuthUser {
+    if ([anAuthUser length] && ![anAuthUser isEqualToString:authUser]) {
+        [authUser release];
+        authUser = [anAuthUser retain];
+        
+        @synchronized(self) {
+            updatePithos = YES;
+            resetSyncDaemonLocalState = YES;
+            [syncLastCompleted release];
+            syncLastCompleted = nil;
+
+        }
+    }
+}
+
+- (void)setAuthToken:(NSString *)anAuthToken {
+    if ([anAuthToken length] && ![anAuthToken isEqualToString:authToken]) {
+        [authToken release];
+        authToken = [anAuthToken retain];
+        
+        @synchronized(self) {
+            updatePithos = YES;
+        }
+    }
+}
+
+- (NSString *)storageURLPrefix {
+    if (![self urlIsValid:storageURLPrefix]) {
+        [storageURLPrefix release];
+        if (versionResource)
+            storageURLPrefix = [[self.serverURL stringByAppendingFormat:@"/%@", versionResource] retain];
+        else
+            storageURLPrefix = [self.serverURL copy];
+    }
+    return storageURLPrefix;
+}
+
+- (void)setStorageURLPrefix:(NSString *)aStorageURLPrefix {
+    if (![self.storageURLPrefix isEqualToString:aStorageURLPrefix] && [self urlIsValid:aStorageURLPrefix]) {
+        [storageURLPrefix release];
+        storageURLPrefix = [aStorageURLPrefix retain];
+    }
+}
+
+- (NSString *)authURL {
+    if (![self urlIsValid:authURL]) {
+        [authURL release];
+        if (versionResource)
+            authURL = [[self.serverURL stringByAppendingFormat:@"/%@", versionResource] retain];
+        else
+            authURL = [self.serverURL copy];
+    }
+    return authURL;
+}
+
+- (void)setAuthURL:(NSString *)anAuthURL {
+    if (![self.authURL isEqualToString:anAuthURL] && [self urlIsValid:anAuthURL]) {
+        [authURL release];
+        authURL = [anAuthURL retain];
+    }
+}
+
+- (NSString *)publicURLPrefix {
+    if (![self urlIsValid:publicURLPrefix]) {
+        [publicURLPrefix release];
+        if (publicResource)
+            publicURLPrefix = [[self.serverURL stringByAppendingFormat:@"/%@", publicResource] retain];
+        else
+            publicURLPrefix = [self.serverURL copy];
+    }
+    return publicURLPrefix;
+}
+
+- (void)setPublicURLPrefix:(NSString *)aPublicURLPrefix {
+    if (![self.publicURLPrefix isEqualToString:aPublicURLPrefix] && [self urlIsValid:aPublicURLPrefix]) {
+        [publicURLPrefix release];
+        publicURLPrefix = [aPublicURLPrefix retain];
+    }
+}
+
+- (NSString *)loginURLPrefix {
+    if (![self urlIsValid:loginURLPrefix]) {
+        [loginURLPrefix release];
+        if (loginResource)
+            loginURLPrefix = [[self.serverURL stringByAppendingFormat:@"/%@", loginResource] retain];
+        else
+            loginURLPrefix = [self.serverURL copy];
+    }
+    return loginURLPrefix;
+}
+
+- (void)setLoginURLPrefix:(NSString *)aLoginURLPrefix {
+    if (![self.loginURLPrefix isEqualToString:aLoginURLPrefix] && [self urlIsValid:aLoginURLPrefix]) {
+        [loginURLPrefix release];
+        loginURLPrefix = [aLoginURLPrefix retain];
+    }
+}
+
+- (ASIPithos *)pithos {
+    @synchronized(self) {
+        if (!pithos || updatePithos) {
+            [pithos release];
+            pithos = [[ASIPithos pithos] retain];
+            pithos.authUser = authUser;
+            pithos.authToken = authToken;
+            pithos.storageURLPrefix = self.storageURLPrefix;
+            pithos.authURL = self.authURL;
+            pithos.publicURLPrefix = self.publicURLPrefix;
+
+            if (accountNode && ![accountNode.pithos isEqualTo:pithos]) {
+                accountNode.pithos = pithos;
+                if (active)
+                    [accountNode refreshInfo];
+            }
+            
+            updatePithos = NO;
+        }
+    }
+    return pithos;
+}
+
+- (PithosAccountNode *)accountNode {
+    if (!accountNode) {
+        accountNode = [[PithosAccountNode alloc] initWithPithos:self.pithos];
+    }
+    return accountNode;
+}
+
+#pragma mark -
+#pragma mark Actions
+
+- (void)authenticateWithServerURL:(NSString *)aServerURL authUser:(NSString *)anAuthUser authToken:(NSString *)anAuthToken {
+    self.serverURL = aServerURL;
+    self.authUser = anAuthUser;
+    self.authToken = anAuthToken;
+    NSLog(@"Account: %@\nauthentication", self);
+    if (![authUser length] || ![authToken length]) {
+        self.active = NO;
+        self.syncActive = NO;
+        // XXX Show preferences with self as the selected account?
+    } else  {
+        self.active = YES;
+        if (syncDaemon) {
+            self.syncDaemon.pithos = self.pithos;
+            if (self.syncActive)
+                [self.syncDaemon startDaemon];
+        }
+    }
+}
+
+- (void)loginWithServerURL:(NSString *)aServerURL {
+    self.serverURL = aServerURL;
+    NSProcessInfo *processInfo = [NSProcessInfo processInfo];
+    NSString *loginURL = [NSString stringWithFormat:@"%@?next=pithos://%@_%d/%@", 
+                          self.loginURLPrefix, [processInfo processName], [processInfo processIdentifier], self.name];
+    NSLog(@"Account: %@\nloginURL: %@", self, loginURL);
+    [[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:loginURL]];
+}
+
+- (void)updateSyncWithSyncActive:(BOOL)aSyncActive syncDirectoryPath:(NSString *)aSyncDirectoryPath {
+    self.syncDirectoryPath = aSyncDirectoryPath;
+    self.syncActive = aSyncActive;
+    if (syncDaemon) {
+        self.syncDaemon.directoryPath = self.syncDirectoryPath;
+        if (self.syncActive)
+            [self.syncDaemon startDaemon];
+    }    
+}
+
+#pragma mark -
+#pragma mark NSCoding
+
+- (id)initWithCoder:(NSCoder *)decoder {
+    if ((self = [super init])) {
+        self.uniqueName = [decoder decodeObjectForKey:@"uniqueName"];
+        self.active = [decoder decodeBoolForKey:@"active"];
+        name = [[decoder decodeObjectForKey:@"name"] retain];
+
+        self.syncActive = [decoder decodeBoolForKey:@"syncActive"];
+        self.syncDirectoryPath = [decoder decodeObjectForKey:@"syncDirectoryPath"];
+        self.syncContainerName = [decoder decodeObjectForKey:@"syncContainerName"];
+        self.syncLastCompleted = [decoder decodeObjectForKey:@"syncLastCompleted"];
+        
+        self.serverURL = [decoder decodeObjectForKey:@"serverURL"];
+        self.versionResource = [decoder decodeObjectForKey:@"versionResource"];
+        self.loginResource = [decoder decodeObjectForKey:@"loginResource"];
+        self.publicResource = [decoder decodeObjectForKey:@"publicResource"];
+        
+        self.authUser = [decoder decodeObjectForKey:@"authUser"];
+        self.authToken = [decoder decodeObjectForKey:@"authToken"];
+        self.storageURLPrefix = [decoder decodeObjectForKey:@"storageURLPrefix"];
+        self.authURL = [decoder decodeObjectForKey:@"authURL"];
+        self.publicURLPrefix = [decoder decodeObjectForKey:@"publicURLPrefix"];
+        self.loginURLPrefix = [decoder decodeObjectForKey:@"loginURLPrefix"];
+        
+        if (![authUser length] || ![authToken length] || ![self.storageURLPrefix length])
+            self.active = NO;
+        
+        resetSyncDaemonLocalState = NO;
+    }
+    return self;
+}
+
+- (void)encodeWithCoder:(NSCoder *)encoder {
+    [encoder encodeObject:uniqueName forKey:@"uniqueName"];
+    [encoder encodeBool:active forKey:@"active"];
+    [encoder encodeObject:name forKey:@"name"];
+    
+    [encoder encodeBool:syncActive forKey:@"syncActive"];
+    [encoder encodeObject:syncDirectoryPath forKey:@"syncDirectoryPath"];
+    [encoder encodeObject:syncContainerName forKey:@"syncContainerName"];
+    [encoder encodeObject:self.syncLastCompleted forKey:@"syncLastCompleted"];
+
+    [encoder encodeObject:serverURL forKey:@"serverURL"];
+    [encoder encodeObject:versionResource forKey:@"versionResource"];
+    [encoder encodeObject:publicResource forKey:@"publicResource"];
+    [encoder encodeObject:loginResource forKey:@"loginResource"];
+    
+    [encoder encodeObject:authUser forKey:@"authUser"];
+    [encoder encodeObject:authToken forKey:@"authToken"];
+    [encoder encodeObject:storageURLPrefix forKey:@"storageURLPrefix"];
+    [encoder encodeObject:authURL forKey:@"authURL"];
+    [encoder encodeObject:publicURLPrefix forKey:@"publicURLPrefix"];
+    [encoder encodeObject:loginURLPrefix forKey:@"loginURLPrefix"];
+}
+
+@end
diff --git a/pithos-macos/PithosAccountNode.m b/pithos-macos/PithosAccountNode.m
index 5a171b7..7f581af 100644
--- a/pithos-macos/PithosAccountNode.m
+++ b/pithos-macos/PithosAccountNode.m
@@ -81,6 +81,15 @@ static NSImage *sharedIcon = nil;
 #pragma mark -
 #pragma mark Properties
 
+- (void)setPithos:(ASIPithos *)aPithos {
+    if (aPithos && ![aPithos isEqualTo:pithos]) {
+        [pithos release];
+        pithos = [aPithos retain];
+        [url release];
+        url = nil;
+    }
+}
+
 - (NSString *)url {
     if (url == nil)
         url = [[NSString alloc] initWithFormat:@"%@%@", 
@@ -298,17 +307,39 @@ static NSImage *sharedIcon = nil;
 
 - (void)accountMetadataRequestFailed:(ASIPithosAccountRequest *)request {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
-    if ([request isEqualTo:applyMetadataAccountRequest]) {
-        [PithosUtilities httpRequestErrorAlertWithRequest:applyMetadataAccountRequest];
-        @synchronized(self) {
-            [applyMetadataAccountRequest release];
-            applyMetadataAccountRequest = nil;
+    NSUInteger retries = [[request.userInfo objectForKey:@"retries"] unsignedIntegerValue];
+    if (retries > 0) {
+        ASIPithosAccountRequest *newRequest = (ASIPithosAccountRequest *)[PithosUtilities copyRequest:request];
+        [(NSMutableDictionary *)(newRequest.userInfo)setObject:[NSNumber numberWithUnsignedInteger:(--retries)] forKey:@"retries"];
+        if ([request isEqualTo:applyMetadataAccountRequest]) {
+            @synchronized(self) {
+                [applyMetadataAccountRequest release];
+                applyMetadataAccountRequest = newRequest;
+            }
+        } else if ([request isEqualTo:refreshMetadataAccountRequest]) {
+            @synchronized(self) {
+                [refreshMetadataAccountRequest release];
+                refreshMetadataAccountRequest = newRequest;
+            }
         }
-    } else if ([request isEqualTo:refreshMetadataAccountRequest]) {
-        [PithosUtilities httpRequestErrorAlertWithRequest:refreshMetadataAccountRequest];
-        @synchronized(self) {
-            [refreshMetadataAccountRequest release];
-            refreshMetadataAccountRequest = nil;
+        [[PithosUtilities prepareRequest:newRequest priority:[[newRequest.userInfo objectForKey:@"priority"] integerValue]] startAsynchronous];
+    } else {
+        if ([request isEqualTo:applyMetadataAccountRequest]) {
+            dispatch_async(dispatch_get_main_queue(), ^{
+                [PithosUtilities httpRequestErrorAlertWithRequest:applyMetadataAccountRequest];
+            });
+            @synchronized(self) {
+                [applyMetadataAccountRequest release];
+                applyMetadataAccountRequest = nil;
+            }
+        } else if ([request isEqualTo:refreshMetadataAccountRequest]) {
+            dispatch_async(dispatch_get_main_queue(), ^{
+                [PithosUtilities httpRequestErrorAlertWithRequest:refreshMetadataAccountRequest];
+            });
+            @synchronized(self) {
+                [refreshMetadataAccountRequest release];
+                refreshMetadataAccountRequest = nil;
+            }
         }
     }
     [pool drain];
diff --git a/pithos-macos/PithosActivity.h b/pithos-macos/PithosActivity.h
index 6569d69..54b49ef 100644
--- a/pithos-macos/PithosActivity.h
+++ b/pithos-macos/PithosActivity.h
@@ -36,6 +36,7 @@
 // or implied, of GRNET S.A.
 
 #import <Foundation/Foundation.h>
+@class PithosAccount;
 
 typedef enum  {
     PithosActivityUpload, 
@@ -52,13 +53,15 @@ typedef enum  {
     NSString *message;
     NSUInteger totalBytes;
     NSUInteger currentBytes;
+    PithosAccount *pithosAccount;
 }
 
-- (id)initWithType:(PithosActivityType)aType;
+- (id)initWithType:(PithosActivityType)aType pithosAccount:(PithosAccount *)aPithosAccount;
 
 @property (nonatomic, assign) PithosActivityType type;
 @property (nonatomic, copy) NSString *message;
 @property (nonatomic, assign) NSUInteger totalBytes;
 @property (nonatomic, assign) NSUInteger currentBytes;
+@property (nonatomic, assign) PithosAccount *pithosAccount;
 
 @end
diff --git a/pithos-macos/PithosActivity.m b/pithos-macos/PithosActivity.m
index 327a106..1b4c16b 100644
--- a/pithos-macos/PithosActivity.m
+++ b/pithos-macos/PithosActivity.m
@@ -36,18 +36,20 @@
 // or implied, of GRNET S.A.
 
 #import "PithosActivity.h"
+#import "PithosAccount.h"
 
 @implementation PithosActivity
-@synthesize type, message, totalBytes, currentBytes;
+@synthesize type, message, totalBytes, currentBytes, pithosAccount;
 
 #pragma mark -
 #pragma mark Object Lifecycle
 
-- (id)initWithType:(PithosActivityType)aType {
+- (id)initWithType:(PithosActivityType)aType pithosAccount:(PithosAccount *)aPithosAccount {
     if ((self = [super init])) {
         type = aType;
         totalBytes = 0;
         currentBytes = 0;
+        pithosAccount = aPithosAccount;
     }
     return self;
 }
@@ -58,8 +60,12 @@
 }
 
 - (NSString *)description {
-    return [NSString stringWithFormat:@"type: %lu, message: %@, totalBytes: %lu, currentBytes: %lu", 
-            type, message, totalBytes, currentBytes];
+    if (pithosAccount)
+        return [NSString stringWithFormat:@"type: %lu, message: %@, totalBytes: %lu, currentBytes: %lu, pithosAccount: %@", 
+                type, message, totalBytes, currentBytes, pithosAccount.name];
+    else
+        return [NSString stringWithFormat:@"type: %lu, message: %@, totalBytes: %lu, currentBytes: %lu", 
+                type, message, totalBytes, currentBytes];
 }
 
 @end
